#!/usr/bin/perl -w
# Xmsgd 
# Copyright (C) 2001 Thomas Vander Stichele <thomas@apestaart.org>
# 
# msgdmail.pl: a mail checker for Xmsgd
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.
#
# Version 0.6.3
#
# last changed : 26/07/2001
#

use Socket;
use IO::Handle;

my $MSGD_FIFO = "/usr/local/share/Xmsgd/msgd.fifo";
my $CONF_FILE = "/usr/local/share/Xmsgd/etc/msgmaild.conf";

use vars qw(@mailboxes $sleep_time);
require $CONF_FILE;

sub pop_login ($)
{
  my $mb_r = shift;

  my ($remote, $port, $iaddr, $paddr, $proto);
  my ($user, $pass);
  
  $remote = $mb_r->{"server"};
  $user =   $mb_r->{"username"};
  $pass =   $mb_r->{"password"};

  $port = 110;


#  $iaddr = inet_aton ($remote) || die "no host: $remote";
#  $iaddr = gethostbyname ($remote);
  #if ($port =~ /\D/) { $port = getservbyname ($port, 'tcp') }

  if (!($iaddr = inet_aton ($remote)))
  {
    print "ERROR: no host $remote\n";
    return 0;
  }
  $paddr = sockaddr_in ($port, $iaddr);
  $proto = getprotobyname ('tcp');
  socket (SOCK, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";
  SOCK->autoflush (1);

  if (! (socket (SOCK, PF_INET, SOCK_STREAM, $proto)))
  {
    print "ERROR: socket: $!\n";
    return 0;
  }
  connect (SOCK, $paddr) || die "connect: $!";
  $line = <SOCK>;
  #print "DEBUG: first line: $line\n";
  if (!$line)
  {
    print "ERROR: could not read line from socket: $!\n";
    return 0;
  }

  print SOCK "USER $user\r\n";
  $line = <SOCK>;
  #print "DEBUG: USER line: $line\n";
  if (! ($line =~ /^\+/))
  {
    print "ERROR: username not accepted; server returned $line\n";
    return 0;
  }

  print SOCK "PASS $pass\r\n";
  $line = <SOCK>;
  #print "DEBUG: PASS line: $line\n";
  if (! ($line =~ /^\+/))
  {
    print "ERROR: password not accepted; server returned $line\n";
    return 0;
  }

  print SOCK "STAT\r\n";
  $line = <SOCK>;
  #print "DEBUG: $line\n";
  $line =~ /^\+OK (\d+)/;
  my $total = $1;
  
  print SOCK "LAST\r\n";
  $line = <SOCK>;
  $line =~ /^\+OK (\d+)/;
  my $read = $1;

  print SOCK "QUIT\r\n";
  close SOCK;
  return ($total - $read);
}

# start with a fork
if (fork ())
{
  exit;
}

# check if msgd.pl is running

$command = "ps h -C msgd.pl";
$result = `$command`;
if (!$result)
{
  system ("msgd.pl");
}

while (1)
{
  foreach $mailbox_hr (@mailboxes)
  {
    #print "Checking mailbox ", $mailbox_hr->{"name"}, "\n";
    if ($mailbox_hr->{"type"} eq "pop3")
    {
      my $unread = pop_login ($mailbox_hr);
      if ($unread)
      {
        my $line = "You have $unread message";
        if ($unread != 1) { $line .= "s"; }
        $line .= " waiting as ".$mailbox_hr->{"name"};
        $command = "echo mail $line > $MSGD_FIFO";
        system $command;
      }
    }
  }  
  sleep $sleep_time;
}

